/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSColorPicker;

import dstep.appkit.NSButtonCell;
import dstep.appkit.NSColorList;
import dstep.appkit.NSColorPanel;
import dstep.appkit.NSColorPicking;
import dstep.appkit.NSImage;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSColorPicker : NSObject, INSColorPickingDefault
{
	mixin (ObjcWrap);

	NSColorPicker initWithPickerMask (NSUInteger mask, NSColorPanel owningColorPanel)
	{
		id result = invokeObjcSelf!(id, "initWithPickerMask:colorPanel:", NSUInteger, NSColorPanel)(mask, owningColorPanel);
		return result is this.objcObject ? this : (result !is null ? new NSColorPicker(result) : null);
	}

	this (NSUInteger mask, NSColorPanel owningColorPanel)
	{
		super(NSColorPicker.alloc.initWithPickerMask(mask, owningColorPanel).objcObject);
	}

	NSColorPanel colorPanel ()
	{
		return invokeObjcSelf!(NSColorPanel, "colorPanel");
	}

	NSImage provideNewButtonImage ()
	{
		return invokeObjcSelf!(NSImage, "provideNewButtonImage");
	}

	void insertNewButtonImage (NSImage newButtonImage, NSButtonCell buttonCell)
	{
		return invokeObjcSelf!(void, "insertNewButtonImage:in:", NSImage, NSButtonCell)(newButtonImage, buttonCell);
	}

	void viewSizeChanged (Object sender)
	{
		return invokeObjcSelf!(void, "viewSizeChanged:", Object)(sender);
	}

	void attachColorList (NSColorList colorList)
	{
		return invokeObjcSelf!(void, "attachColorList:", NSColorList)(colorList);
	}

	void detachColorList (NSColorList colorList)
	{
		return invokeObjcSelf!(void, "detachColorList:", NSColorList)(colorList);
	}

	void setMode (int mode)
	{
		return invokeObjcSelf!(void, "setMode:", int)(mode);
	}

	NSString buttonToolTip ()
	{
		return invokeObjcSelf!(NSString, "buttonToolTip");
	}

	NSSize minContentSize ()
	{
		return invokeObjcSelf!(NSSize, "minContentSize");
	}

	void insertNewButtonImage (NSImage newButtonImage, NSButtonCell buttonCell)
	{
		return invokeObjcSelf!(void, "insertNewButtonImage:in:", NSImage, NSButtonCell)(newButtonImage, buttonCell);
	}

	void viewSizeChanged (Object sender)
	{
		return invokeObjcSelf!(void, "viewSizeChanged:", Object)(sender);
	}

	void alphaControlAddedOrRemoved (Object sender)
	{
		return invokeObjcSelf!(void, "alphaControlAddedOrRemoved:", Object)(sender);
	}

	void attachColorList (NSColorList colorList)
	{
		return invokeObjcSelf!(void, "attachColorList:", NSColorList)(colorList);
	}

	void detachColorList (NSColorList colorList)
	{
		return invokeObjcSelf!(void, "detachColorList:", NSColorList)(colorList);
	}
}

