/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSEPSImageRep;

import dstep.appkit.NSImageRep;
import dstep.appkit.NSPDFImageRep;
import dstep.foundation.NSData;
import dstep.foundation.NSGeometry;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSEPSImageRep : NSImageRep
{
	mixin (ObjcWrap);

	static Object imageRepWithData (NSData epsData)
	{
		return invokeObjcSelfClass!(Object, "imageRepWithData:", NSData)(epsData);
	}

	NSEPSImageRep initWithData (NSData epsData)
	{
		id result = invokeObjcSelf!(id, "initWithData:", NSData)(epsData);
		return result is this.objcObject ? this : (result !is null ? new NSEPSImageRep(result) : null);
	}

	this (NSData epsData)
	{
		super(NSEPSImageRep.alloc.initWithData(epsData).objcObject);
	}

	void prepareGState ()
	{
		return invokeObjcSelf!(void, "prepareGState");
	}

	NSData EPSRepresentation ()
	{
		return invokeObjcSelf!(NSData, "EPSRepresentation");
	}

	NSRect boundingBox ()
	{
		return invokeObjcSelf!(NSRect, "boundingBox");
	}
}

